#!/bin/sh
function err() {
- echo 2>&1 "-E- $1"
+ echo >&2 "-E- $1"
exit 1
}
-if [ ! -z "$3" ]; then
- mountdir=$3
-fi
+[ -n "$3" ] && mountdir=$3
-if [ -z "$mountdir" ]; then
- echo >&2 '$mountdir must be set'
- exit 1
-fi
-
-if [ -z "$rundir" ]; then
- echo >&2 '$rundir must be set'
- exit 1
-fi
+[ -z "$mountdir" ] && err '$mountdir must be set'
+[ -z "$rundir" ] && err '$rundir must be set'
export PATH=${rundir%%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
-if [ ! -d "$1" -o ! -d "$2" ]; then
- echo >&2 "Usage: $0 <source-dir> <target-dir> [<mnt-dir>]"
- echo >&2 " source-dir - directory on backup disks to restore from"
- echo >&2 " target-dir - directory to restore files to"
- echo >&2 " mnt-dir - directory where backup disk is mounted (optional)"
- echo >&2 "Example: $0 / / /mnt/cdrom"
- exit 1
+if [ ! -d "$mountdir$1" -o ! -d "$2" ]; then
+ err "
+Usage: $0 <source-dir> <relocate-dir> [<mnt-dir>]
+ source-dir - directory on backup disks to restore from (relative to $mountdir)
+ relocate-dir - base directory to restore files to (usually /)
+ mnt-dir - directory where backup disk is mounted (optional)
+
+ Examples:
+ % $0 / / /mnt/cdrom # Restore everything from disks (explicitly specifying dvd mount point.)
+ % $0 / / # Restore everything from disks
+ % $0 /home / # Restore only files under /home on disks to /home on the system
+ % $0 /home /home # Restore files under /home on disks to /home/home on the system (probably not what you want.)
+"
fi
device=$(mount | grep "on ${mountdir%%/} " | awk '{print$1}')
-if [ -z "$device" ]; then
- echo >&2 "Cannot determine cdrom device"
- exit 1
-fi
+[ -z "$device" ] && err "Cannot determine cdrom device"
cp ${mountdir%%/}/backups.db ${mountdir%%/}/backup-status.txt $rundir
dbfile=${rundir%%/}/backups.db
while ! $success; do
eject $device
[ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
- echo >&2 "Please insert backup disk: $date"
- echo >&2 "Press Enter to continue"
+ echo "Please insert backup disk: $date"
+ echo "Press Enter to continue"
read bogus
eject -t $device
done
rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
- cat $dbfile | files-from-date.sh $date | grep -z -e "${1}" | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
+ cat $dbfile | files-from-date.sh $date | grep -z -Z -e "^${1}" | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
done